<template>
    <li
        v-if="model"
        class="w-full"
    >
        <div
            :class="{bold: hasChildren}"
            class="item-row flex justify-start space-x-2 items-center"
            @click="toggle"
        >
            <i
                class="arrow-icon"
                role="presentation"
            />
            <span
                v-if="hasChildren"
                class="mr-1 toggle-img-span"
            >
                <svg
                    v-if="isOpen"
                    xmlns="http://www.w3.org/2000/svg"
                    x="0px"
                    y="0px"
                    class="w-6 h-6"
                    viewBox="0 0 30.334 30.334"
                    xml:space="preserve"
                >
                    <g>
                        <path d="M15.167,30.334c-8.362,0-15.166-6.805-15.166-15.167C0.001,6.804,6.805,0,15.167,0c8.361,0,15.166,6.804,15.166,15.167 C30.333,23.529,23.528,30.334,15.167,30.334z M15.167,4C9.01,4,4.001,9.009,4.001,15.167S9.01,26.334,15.167,26.334 s11.166-5.009,11.166-11.167S21.324,4,15.167,4z M24.824,15.167c0-1.657-1.343-3-3-3H8.509c-1.657,0-3,1.343-3,3 c0,1.656,1.343,3,3,3h13.315C23.481,18.167,24.824,16.823,24.824,15.167z" fill="currentColor" />
                    </g>
                </svg>
                <svg
                    v-else
                    class="w-6 h-6"
                    viewBox="0 0 32 32"
                    xmlns="http://www.w3.org/2000/svg"
                >
                    <g>
                        <path d="M16,0A16,16,0,1,0,32,16,16,16,0,0,0,16,0Zm0,28A12,12,0,1,1,28,16,12.013,12.013,0,0,1,16,28Z" fill="currentColor" />
                        <path d="M22.02,14H18V9.98A1.979,1.979,0,0,0,16.02,8h-.04A1.979,1.979,0,0,0,14,9.98V14H9.98A1.979,1.979,0,0,0,8,15.98v.04A1.979,1.979,0,0,0,9.98,18H14v4.02A1.979,1.979,0,0,0,15.98,24h.04A1.979,1.979,0,0,0,18,22.02V18h4.02A1.979,1.979,0,0,0,24,16.02v-.04A1.979,1.979,0,0,0,22.02,14Z" fill="currentColor" />
                    </g>
                </svg>
            </span>
            <span
                v-else
            >
                <svg
                    xmlns="http://www.w3.org/2000/svg"
                    class="w-6 h-6"
                    x="0px"
                    y="0px"
                    viewBox="0 0 167.751 167.751"  xml:space="preserve"
                >
                    <path d="M0,83.875c0,46.249,37.626,83.875,83.875,83.875s83.875-37.626,83.875-83.875S130.125,0,83.875,0S0,37.626,0,83.875z M83.875,152.751C45.897,152.751,15,121.854,15,83.875c0-16.292,5.698-31.272,15.191-43.078l96.762,96.762 C115.147,147.052,100.168,152.751,83.875,152.751z M152.75,83.875c0,16.292-5.698,31.272-15.19,43.078L40.797,30.191 C52.603,20.698,67.583,15,83.875,15C121.853,15,152.75,45.897,152.75,83.875z" fill="currentColor" />
                </svg>
            </span>
            <span>
                <template
                    v-if="parseInt(model.ranking) === 0"
                >
                    <img
                        :src="`/img/ranking/investor-${parseFloat(model.active_investment) > 0 ? 'active' : 'inactive'}.png`"
                        class="w-6 h-6 rounded-full bg-white"
                    />
                </template>
                <template
                    v-else
                >
                    <img
                        :src="`/img/ranking/bm-${model.ranking}-${parseFloat(model.active_investment) > 0 ? 'active' : 'inactive'}.png`"
                        class="w-6 h-6 rounded-full bg-white"
                    />
                </template>
            </span>
            <span>{{ model.text }}</span>
        </div>
        <ul
          v-show="isOpen"
          v-if="hasChildren"
          class="tree-list"
        >
            <tree-branch
                v-for="(child, index) in model.childrens"
                :key="index"
                :item="child"
                :url="url"
                class="item"
            />
        </ul>
    </li>
</template>

<script setup>
import {ref, computed, onMounted} from "vue";
import axios from "axios";

const props = defineProps({
    item: {
        required: true,
        type: Object,
        default: null,
    },
    url: {
        required: true,
        type: String
    }
});

const model = ref(null);
const isOpen = ref(false);
const hasChildren = computed(() => {
    if (!model.value) return false;
    return model.value.has_children || false;
});

const toggle = async () => {
    if (hasChildren.value) {
        if (!model.value.childrens || !model.value.childrens.length) {
            const data = await axios.post(props.url, {
                id: model.value.id,
                children_only: 1,
            });

            if (data.childrens) {
                model.value.childrens = data.childrens;
            }
        }

        isOpen.value = !isOpen.value;
    }
};

onMounted(() => {
    model.value = {...props.item};
});
</script>
